<?php
/*+***********************************************************************************************************************************
 * The contents of this file are subject to the YetiForce Public License Version 1.1 (the "License"); you may not use this file except
 * in compliance with the License.
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
 * See the License for the specific language governing rights and limitations under the License.
 * The Original Code is YetiForce.
 * The Initial Developer of the Original Code is YetiForce. Portions created by YetiForce are Copyright (C) www.yetiforce.com. 
 * All Rights Reserved.
 *************************************************************************************************************************************/

class Inventory_FindDuplicates_View extends Vtiger_FindDuplicates_View {
	/**
	 * Function to get the list of Script models to be included
	 * @param Vtiger_Request $request
	 * @return <Array> - List of Vtiger_JsScript_Model instances
	 */
	function getFooterScripts(Vtiger_Request $request) {
		$headerScriptInstances = parent::getFooterScripts($request);
		$moduleName = $request->getModule();

		//Added to remove the module specific js, as they depend on inventory files
		$mainEditFile = 'modules.Vtiger.resources.Edit';
		$moduleEditFile = 'modules.'.$moduleName.'.resources.Edit';

		unset($headerScriptInstances[$mainEditFile]);
		unset($headerScriptInstances[$moduleEditFile]);

		$jsFileNames = array(
			$mainEditFile,
			'modules.Inventory.resources.Edit',
			$moduleEditFile,
		);
		$jsScriptInstances = $this->checkAndConvertJsScripts($jsFileNames);
		$headerScriptInstances = array_merge($headerScriptInstances, $jsScriptInstances);
		return $headerScriptInstances;
	}
}
